#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "keylistener.h"
#include "bcprocess.h"
#include <QMainWindow>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void append(QChar c);
    void append(QString s);
    void setIbase(int value);
    void setObase(int value);
    void setScale(int value);

private:
    Ui::MainWindow *ui;
    BcProcess bc;

private slots:
    void on_pb0_clicked();
    void on_pb1_clicked();
    void on_pb2_clicked();
    void on_pb3_clicked();
    void on_pb4_clicked();
    void on_pb5_clicked();
    void on_pb6_clicked();
    void on_pb7_clicked();
    void on_pb8_clicked();
    void on_pb9_clicked();
    void on_pbDot_clicked();
    void on_pbBracketOpen_clicked();
    void on_pbBracketClose_clicked();
    void on_pbPlus_clicked();
    void on_pbMinus_clicked();
    void on_pbMultiply_clicked();
    void on_pbDivide_clicked();
    void on_pbDelete_clicked();
    void on_pbFn_clicked();
    void on_pbVariable_clicked();
    void on_pbEnter_clicked();
    void displayOutput(QString text);
    void displayError(QString text);

protected:
    KeyListener* keyListener;
};

#endif // MAINWINDOW_H
